package com.cit.sellfan.ui.pannelli;

import java.util.Collection;

import com.cit.sellfan.business.VariabiliGlobali;
import com.vaadin.data.Property;
import com.vaadin.shared.ui.label.ContentMode;
import com.vaadin.ui.Alignment;
import com.vaadin.ui.CustomComponent;
import com.vaadin.ui.Panel;
import com.xdev.ui.XdevLabel;
import com.xdev.ui.XdevVerticalLayout;
import com.xdev.ui.entitycomponent.combobox.XdevComboBox;


public class pannelloHelpPotenza extends Panel {
	private VariabiliGlobali l_VG;
    private int potenzaIndexSelezionato = -1;
    private int elenco[] = null;

	/**
	 * 
	 */
	public pannelloHelpPotenza() {
		super();
		this.initUI();
	}

	public void setVariabiliGlobali(final VariabiliGlobali variabiliGlobali) {
		this.l_VG = variabiliGlobali;
	}
	
	public void Nazionalizza() {
		this.labelRpmConsigliati.setValue("<b>" + this.l_VG.utilityTraduzioni.TraduciStringa("Potenze Motori Disponibili") + "</b>");
	}
	
	public void initPannello(final double elencoPotenze[]) {
		Nazionalizza();
		this.elenco = new int[elencoPotenze.length];
		this.potenzaIndexSelezionato = -1;
		this.comboBoxPotenze.setEnabled(false);
		this.comboBoxPotenze.removeAllItems();
        this.l_VG.fmtNd.setMaximumFractionDigits(3);
        this.l_VG.fmtNd.setMinimumFractionDigits(3);
        for (int i=0 ; i<elencoPotenze.length ; i++) {
        	this.elenco[i] = (int)(elencoPotenze[i] * 1000.);
        	this.comboBoxPotenze.addItem(this.l_VG.fmtNd.format(elencoPotenze[i]) + " kW");
        }
        final Collection<?> coll = this.comboBoxPotenze.getItemIds();
        if (coll.size() >= 1) {
			this.comboBoxPotenze.setEnabled(true);
		}
	}
	
    public int getIndexPotenzaSelezionato() {
        return this.potenzaIndexSelezionato;
    }
	/**
	 * Event handler delegate method for the {@link XdevComboBox}
	 * {@link #comboBoxPotenze}.
	 *
	 * @see Property.ValueChangeListener#valueChange(Property.ValueChangeEvent)
	 * @eventHandlerDelegate Do NOT delete, used by UI designer!
	 */
	private void comboBoxPotenze_valueChange(final Property.ValueChangeEvent event) {
		this.potenzaIndexSelezionato = -1;
		if (this.comboBoxPotenze.getValue() == null) {
			return;
		}
		try {
			final String str = event.getProperty().getValue().toString();
			final String strSpli[] = str.split(" ");
			final int potenza = (int)(Double.parseDouble(strSpli[0]) * 1000.);
			for (int i=0 ; i<this.elenco.length ; i++) {
				if (potenza == this.elenco[i]) {
					this.potenzaIndexSelezionato = i;
					break;
				}
			}
		} catch (final Exception e) {
			//Notification.show(e.toString());
		}
	}

	/*
	 * WARNING: Do NOT edit!<br>The content of this method is always regenerated by
	 * the UI designer.
	 */
	// <generated-code name="initUI">
	private void initUI() {
		this.verticalLayout = new XdevVerticalLayout();
		this.labelRpmConsigliati = new XdevLabel();
		this.comboBoxPotenze = new XdevComboBox<>();
	
		this.labelRpmConsigliati.setValue("<b>Rpm consigliati");
		this.labelRpmConsigliati.setContentMode(ContentMode.HTML);
	
		this.labelRpmConsigliati.setSizeUndefined();
		this.verticalLayout.addComponent(this.labelRpmConsigliati);
		this.verticalLayout.setComponentAlignment(this.labelRpmConsigliati, Alignment.MIDDLE_CENTER);
		this.comboBoxPotenze.setSizeUndefined();
		this.verticalLayout.addComponent(this.comboBoxPotenze);
		this.verticalLayout.setComponentAlignment(this.comboBoxPotenze, Alignment.MIDDLE_CENTER);
		final CustomComponent verticalLayout_spacer = new CustomComponent();
		verticalLayout_spacer.setSizeFull();
		this.verticalLayout.addComponent(verticalLayout_spacer);
		this.verticalLayout.setExpandRatio(verticalLayout_spacer, 1.0F);
		this.verticalLayout.setSizeFull();
		this.setContent(this.verticalLayout);
		this.setSizeFull();
	
		this.comboBoxPotenze.addValueChangeListener(new Property.ValueChangeListener() {
			@Override
			public void valueChange(final Property.ValueChangeEvent event) {
				pannelloHelpPotenza.this.comboBoxPotenze_valueChange(event);
			}
		});
	} // </generated-code>

	// <generated-code name="variables">
	private XdevLabel labelRpmConsigliati;
	private XdevComboBox<?> comboBoxPotenze;
	private XdevVerticalLayout verticalLayout;
	// </generated-code>

}
